=== Post Grid By PickPlugins ===
Contributors: PickPlugins
Donate link: https://pickplugins.com/
Tags: popup Blocks, form block, post meta block
Requires at least: 5.0.0
Tested up to: 6.7
Stable tag: 2.3.9
License: GPLv2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html

Post Grid is a powerful WordPress plugin for creating customizable post grid layouts with advanced query options, allowing users to display posts dynamically with filters, pagination, and multiple design variations.


== Description ==

**Post Grid for WordPress – The Ultimate Grid Layout Plugin**

Post Grid is a powerful WordPress plugin designed to display posts, pages, or custom post types in a visually stunning grid layout. Whether you’re running a blog, eCommerce store, portfolio site, or business website, Post Grid allows you to showcase content in an organized and engaging way.

🚀 **Start creating beautiful post grids today!**

🔗 **[Live Demo](https://pickplugins.com/demo/post-grid/)**  
🔗 **[Premium Features](https://pickplugins.com/post-grid/)**  
🔗 **[Documentation](https://pickplugins.com/documentation/post-grid/)**  
🔗 **[Support](https://www.pickplugins.com/support/)**  
🔗 **[Video Tutorials](https://www.youtube.com/watch?v=YVtsIbEb9zs&list=PL0QP7T2SN94Yut5Y0MSVg1wqmqWz0UYpt)**



### **Key Features:**

✅ **Fully Responsive Grid Layout**
   - Works seamlessly on any device.
   - Customizable column settings for desktop, tablet, and mobile.

✅ **Supports Any Custom Post Type**
   - Display content from posts, pages, WooCommerce products, portfolios, or any other custom post type.
   - Select multiple post types for a unified grid display.

✅ **Advanced Query Options**
   - Filter posts by categories, tags, taxonomies, and terms.
   - Customize post order, publish status, and metadata.
   - Exclude or include specific posts by ID.
   - Display posts based on keyword search.

✅ **Skin & Layout Customization**
   - Pre-designed templates and layouts.
   - Drag-and-drop builder for easy grid customization.
   - Apply custom CSS styles for a unique design.

✅ **Pagination & Load More Options**
   - Classic pagination, AJAX-based pagination, and “Load More” buttons.
   - Customizable navigation text and icons.

✅ **Search Input Field**
   - Enable a search box within the grid to help users find content quickly.

✅ **Masonry & Custom Grid Options**
   - Grid item width and height adjustments.
   - Masonry-style layout support.
   - Background color, padding, and margin controls.

### **Premium Features:**

🚀 **Advanced View Types**
   - Filterable grids.
   - Glossary-style view.
   - Carousel slider.
   - Collapsible grid view.

📌 **Post Grid for Archives**
   - Supports category, tag, search, author, and custom taxonomy pages.

🔄 **Advanced Pagination Types**
   - AJAX pagination.
   - Next-Previous navigation.
   - Filterable pagination.
   - AJAX Load More button.

🎥 **Multiple Media Sources**
   - Featured images.
   - Embedded YouTube, Vimeo, Dailymotion, and SoundCloud media.
   - Custom thumbnails and Font Awesome icons.

🛠 **Advanced Filtering & Sorting**
   - Filter posts by taxonomies, terms, or custom filters.
   - Customizable navigation styles, including inline, dropdown, radio, and checkbox views.
   - Custom default active filter and sorting options.

📊 **Meta & Custom Query Support**
   - Meta query for filtering by custom fields.
   - Custom query parameters for advanced data fetching.
   - Sticky post inclusion/exclusion.
   - Date-based filtering and author-based queries.
   - Display password-protected posts.

### **Why Choose Post Grid?**
- **User-friendly** – No coding required, fully customizable.
- **Lightweight & Fast** – Optimized for performance and SEO.
- **Versatile & Feature-rich** – Ideal for blogs, portfolios, WooCommerce stores, and more.


## 3rd Party Plugins Support

### WooCommerce
WooCommerce is the #1 eCommerce plugin for WordPress, and our post grid plugin provides full support for displaying various product elements within the grid. Users can showcase essential product details such as Add to Cart buttons, Full Price, Sale Price, Regular Price, Star Rating, Text Rating, Product Categories, Product Tags, Product Gallery, and Product SKU. This integration ensures that WooCommerce products are visually appealing and easy to navigate.

### Easy Digital Downloads
Easy Digital Downloads is a leading eCommerce solution for selling digital products. Our post grid plugin fully supports displaying crucial elements for downloads, including Price, Variable Prices, Sales Stats, Earnings Stats, Add to Cart buttons, Text Ratings, Download Categories, and Download Tags. This feature allows digital product sellers to effectively present their products in an organized and user-friendly grid layout.

### Advanced Custom Fields
Advanced Custom Fields is the #1 custom fields plugin for WordPress, and we have integrated full support for displaying various meta fields for any post type. Users can showcase data fields such as Text, Textarea, Number, Range, Email, URL, Password, Link, Post Object, Page Link, Taxonomy, User, Relationship, Image, File, WYSIWYG Editor, oEmbed, Select, Checkbox, Radio, Button Group, True/False, Date Picker, Time Picker, Datetime Picker, and Google Map. This integration allows users to customize post grid content dynamically.

### CMB2
CMB2 is another powerful custom fields plugin for WordPress, and our post grid plugin supports displaying multiple meta fields for any post type. Supported fields include Text, Email, URL, Money, Textarea, Select, Checkbox, Radio, Link, File, WYSIWYG Editor, and oEmbed. This ensures flexibility in structuring and displaying custom data within post grids.

### Custom Field Suite
Custom Field Suite is an excellent custom fields plugin for WordPress, and our post grid plugin fully supports displaying various meta fields for any post type. Users can showcase Text, Textarea, Link, Taxonomy, User, Relationship, File, WYSIWYG Editor, Select, True/False, and Date Picker fields, making it easy to manage and present custom content.

### The Events Calendar
The Events Calendar is the #1 event management plugin for WordPress, and our post grid plugin provides full support for displaying event-related elements. Users can showcase Event Categories, Event Tags, Event Start Date, Event End Date, Event URL, Event Cost, Venue Address, Venue City, Venue Country, Venue Province, Venue Zip Code, Venue Phone, Venue URL, Venue Map, Organizer Phone, Organizer Website, and Organizer Email. This integration ensures that events are well-organized and easily accessible within the grid layout.

### Events Manager
Events Manager is another powerful event management plugin for WordPress, and our post grid plugin supports displaying essential elements for event post types. Users can showcase Event Categories, Event Tags, Event Start Date, Event End Date, Event Start Time, Event End Time, Event Spaces, Maximum Spaces, Cut-Off Date, and Cut-Off Time. This feature helps users create engaging and informative event listings within a post grid.




Video Tutorial(with premium version interface)

* [All tutorials](https://www.youtube.com/watch?v=RKb-B_Q72Ak&list=PL2GPPfgLrfWxAZBQc10XCh5wzDSOfPrKB)

## 🏆 Users Feedback For Post Grid

[Miguelapps](https://wordpress.org/support/topic/easy-and-intuitive-plugin-to-use/):

> Easy and intuitive plugin to use

> It meets my expectations and it is what I was looking for to avoid SPA users on my website

[Andrewh2016](https://wordpress.org/support/topic/great-customisable-plugin-well-supported/):

> Great customisable plugin & well supported

> I use this on several sites to achieve a grid layout of posts. It’s really customisable and the support is excellent. Highly recommended.

[Systembit](https://wordpress.org/support/topic/flexible-plugin-excellent-support-2/):

> Flexible plugin, excellent support

> We’ve been happily using it for nearly 5 years now. The plugin is flexible, we were able to customise to suit our needs. It is also simple to use despite all the flexibility. But best of all, the support, even for free users, is fast and good. I can’t recommend this enough. Thanks to everyone at PickPlugins for a great product!

== Installation ==

1. Install as regular WordPress plugin.
2. Go your plugin setting via WordPress Dashboard and find "Post Grid" activate it.

After activate plugin you will see "Post Grid" menu at left side on WordPress dashboard click "New Post Grid" and use the options field "Post Grid"


How to use on page or post
When Post Grid options setup done please publish Post Grid as like post or page

and then copy shortcode from top of Post Grid Options `[post_grid  id="1234" ]`

then paste this shortcode anywhere in your page to display grid

= Minimum Requirements =

- WordPress 5.0.0 or greater
- PHP version 7.3 or greater
- MySQL version 5.6 or greater

= Automatic installation =

1. Go to your WordPress Plugin installation menu (Dashboard > Plugins > Add New)
2. In the search field type Post Grid and press enter.
3. "Install Now" and then click "Active"

= Manual installation =

For Manual installation, you download our product from WordPress directory uploading it to your web-server via your FTP or CPanel application.

1. Download the plugin and unzip it, make sure its under the folder name "post-grid"
2. Using an FTP program or CPanel upload the unzipped plugin folder to your WordPress installation’s wp-content/plugins/ directory.
3. Activate the plugin from the Plugins menu (Dashboard > Plugins > Installed Plugins > Post Grid) within the WordPress admin.

== Frequently Asked Questions ==

= What is a post grid? =

A post grid is a layout format used to display a collection of blog posts or other types of content in a grid-like structure on a website. The grid displays the featured images and titles of the posts in an organized manner, typically with multiple posts shown in rows and columns. The purpose of a post grid is to provide a visually appealing way to showcase a large number of posts, allowing users to quickly browse and find the content they're interested in. Some common applications of post grids include blog homepages, category pages, and archives.

= What is a blog post grid? =

A blog post grid is a type of layout that is used to display a collection of blog posts on a website. The blog posts are arranged in a grid-like structure, with each post represented by its featured image and title. The grid is designed to provide a visually appealing way to showcase a large number of posts, making it easier for users to quickly browse and find the content they're interested in. The post grid is commonly used on blog homepages, category pages, and archives, and can be customized to fit the look and feel of the website. Some popular features of blog post grids include the ability to filter posts by category, the ability to paginate the posts, and the ability to display post metadata such as the date published and the author's name.

= What is Masonry Grid? =

Masonry grid is a layout style for arranging elements in a flexible grid, with the ability to have elements of different sizes, just like a masonry wall. It's commonly used in a variety of contexts such as galleries, blog posts, portfolios, and other similar use cases, where the content elements need to be displayed in a dynamic and organized manner, filling the available space in an optimal way.

In web development, Masonry grid can be implemented using CSS grid, flexbox or JavaScript-based libraries such as Masonry.js, Isotope, or Packery. The main idea behind Masonry grid is to create a grid of items that fit together like stones in a wall, filling any gaps and maximizing the use of space in an aesthetically pleasing way.

= What is Filterable Post Grid? =

Filterable Post Grid is a WordPress plugin that allows you to display posts or custom post types in a grid layout with the ability to filter the displayed content based on categories, tags, or custom taxonomies. This plugin can be used to create a portfolio, gallery, or any other type of grid-based content display. It provides a user-friendly interface for creating and customizing the grid, and it offers a range of styling options to ensure that the grid fits seamlessly into your website design.





= Can I request new features? =

You can ask or request a new feature via wordpress.org forum or please go to our forum page https://pickplugins.com/support/

= Where can I report bugs for this plugin? =

You can report a bug via wordpress.org forum, also we are avilable on official forum https://pickplugins.com/support/



== Screenshots ==



== Changelog ==

= 2.3.9 =
- 2024-03-16 - update - Readme update

= 2.3.8 =
- 2024-03-16 - update - Blocks Removed and Move to https://wordpress.org/plugins/combo-blocks/

= 2.3.7 =
- 2024-02-23 - fix - User Query Block - REST API allow access to admin only.

= 2.3.6 =
- 2024-02-18 - fix - Form Maker Block - creating WC order marked as pending instaed on completed.
- 
= 2.3.5 =
- 2024-02-18 - fix - User query block - Remove roles, capabilities from REST response.
- 2024-02-18 - fix - Update style component to adding predefined properties.

= 2.3.4 =
- 2024-01-12 - fix - Form Maker block - registration form remove tutor LMS registration feature

= 2.3.3 =

- 2024-12-27 - fix - Form Maker block - registration form security issue fixed.
- 2024-12-27 - fix - Block settings tab added under dashboard
- 2024-12-27 - fix - php 7.4 compatibility issue fixed.


= 2.3.2 =

- 2024-12-10 - fix - Form Maker block - registration form security issue fixed.
- 2024-12-05 - add - Style component - some properties added


= 2.3.1 =
- 2024-11-17 - update - Templates picker updated
- 2024-11-17 - add - Taxonomy Builder added
- 2024-11-15 - added - AI Features add on Accordion Block
- 2024-11-13 - added - AI Features add on List Block
- 2024-11-11 - added - AI Features add on Team Members Block
- 2024-11-08 - added - AI Features add on Testimonials Block
- 2024-11-08 - added - AI Features add on Text Block
- 2024-11-08 - added - AI Features add on Image Block
- 2024-11-08 - update - Style component updated.

= 2.3.0 =
- 2024-11-05 - fix - unnecessary CSS output issue fixed.

= 2.2.99 =
- 2024-11-05 - fix - Form Maker block - Frontend js error issue fixed.

= 2.2.98 =
- 2024-11-03 - fix - Form Maker block - Register user security issue improved.
- 2024-10-03 - update - Post Query block update
- 2024-10-18 - update - Dashboard page update.
- 2024-10-18 - update - Terms Query block update
- 2024-10-17 - update - Terms Showcase block update
- 2024-10-16 - update - Image block update
- 2024-10-15 - update - Post Author block update
- 2024-10-15 - update - User Fields block update
- 2024-10-15 - update - Post Query Pagination block update


= 2.2.97 =
- 2024-10-14 - fix - Form Maker block - Register user security issue fixed.


= 2.2.96 =
- 2024-10-06 - fix - missing blocks-styles.css file issue fixed
- 2024-10-06 - fix - Image block - broken image url issue fixed.
- 2024-10-06 - fix - Added block variations picker for few blocks.


= 2.2.95 =
- 2024-10-04 - fix - Block Theme style broken issue fixed.
- 2024-10-04 - fix - WooCommerce broken style issue fixed.
- 2024-10-04 - fix - Image block broken issue fixed.

= 2.2.94 =
- 2024-09-12 - fix - escaping issue fixed for blocks.
- 2024-10-01 - update - Dashboard page update.
- 2024-10-01 - update - Number Counter block update
- 2024-09-30 - update - Image Gallery block update
- 2024-09-29 - update - Filterable Grid - Nav block update
- 2024-09-29 - update - Form Maker block update
- 2024-09-28 - update - Post Date block update
- 2024-09-28 - update - Image Accordion block update
- 2024-09-28 - update - Read More block update
- 2024-09-26 - update - More translation support added.
- 2024-09-21 - added - New component AnimatiOn added
- 2024-09-21 - added - New component Typing Text added
- 2024-09-21 - added - New component Tilt added
- 2024-09-21 - added - New component Tooltip added
- 2024-09-21 - update - Team Members block update
- 2024-09-21 - update - Text block update
- 2024-09-21 - update - Layers block update
- 2024-09-21 - update - Testimonial block update
- 2024-09-18 - update - Image block update
- 2024-09-18 - update - Featured Image block update

= 2.2.93 =
- 2024-09-09 - fix - escaping issue fixed for blocks.
- 2024-09-09 - fix - outputing custom attributs commented out for blocks.
- 2024-09-09 - fix - Tabs blocks js error issue fixed.
